unit Wecker_m;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, MMSystem,
  About;

type
	TAction = (aNIL, aMUp, aMDown, aSUp, aSDown);

  TWeckerForm = class(TForm)
	 LMin10: TLabel;
	 LMin1: TLabel;
	 Label3: TLabel;
    LSek10: TLabel;
	 LSek1: TLabel;
	 BBSekUp: TBitBtn;
	 BBMinDown: TBitBtn;
	 BBMinUp: TBitBtn;
	 BBSekDown: TBitBtn;
	 BBStart: TBitBtn;
	 BBStop: TBitBtn;
	 WeckerTimer: TTimer;
	 SBClear: TSpeedButton;
	 procedure FormCreate(Sender: TObject);
	 procedure BBStartClick(Sender: TObject);
	 procedure BBStopClick(Sender: TObject);
	 procedure WeckerTimerTimer(Sender: TObject);
	 procedure BBMinUpClick(Sender: TObject);
	 procedure BBSekUpClick(Sender: TObject);
	 procedure BBMinDownClick(Sender: TObject);
	 procedure BBSekDownClick(Sender: TObject);
	 procedure FormShow(Sender: TObject);
	 procedure SBClearClick(Sender: TObject);
    procedure BBSekUpMouseUp(Sender: TObject; Button: TMouseButton;
		Shift: TShiftState; X, Y: Integer);
    procedure BBMinUpMouseDown(Sender: TObject; Button: TMouseButton;
		Shift: TShiftState; X, Y: Integer);
	 procedure FormClick(Sender: TObject);
  private
	 { Private-Deklarationen }
	 Minuten, Sekunden	: Integer;
	 AktMin, AktSek		: Integer;
	 RollStatus				: Boolean;
	 What						: TAction;
	 procedure ShowTime;
	 procedure DoRefresh;
  public
	 { Public-Deklarationen }
  end;

var
  WeckerForm: TWeckerForm;

implementation

{$R *.DFM}

procedure TWeckerForm.ShowTime;
begin
	if IsIconic(Application.Handle) then begin
		Application.Title := 'Wecker '+IntToStr(AktMin div 10)+IntToStr(AktMin mod 10)+':'+
												 IntToStr(AktSek div 10)+IntToStr(AktSek mod 10);
	end
	else	begin
				LMin10.Caption := IntToStr(AktMin div 10);
				LMin1.Caption := IntToStr(AktMin mod 10);
				LSek10.Caption := IntToStr(AktSek div 10);
				LSek1.Caption := IntToStr(AktSek mod 10);
			end;
end;

procedure TWeckerForm.FormCreate(Sender: TObject);
begin
	Minuten := 0;
	Sekunden := 0;
	AktMin := 0;
	AktSek := 0;
	ShowTime;
	RollStatus := False;
	What := aNIL;
end;

procedure TWeckerForm.BBStartClick(Sender: TObject);
begin
	BBStart.Enabled := False;
	BBMinUp.Enabled := False;
	BBMinDown.Enabled := False;
	BBSekUp.Enabled := False;
	BBSekDown.Enabled := False;
	BBStop.Enabled := True;
	SBClear.Enabled := False;
   WeckerTimer.Interval := 1000;
	WeckerTimer.Enabled := True;
end;

procedure TWeckerForm.BBStopClick(Sender: TObject);
begin
	WeckerTimer.Enabled := False;
	BBStart.Enabled := True;
	BBMinUp.Enabled := True;
	BBMinDown.Enabled := True;
	BBSekUp.Enabled := True;
	BBSekDown.Enabled := True;
	BBStop.Enabled := False;
	SBClear.Enabled := True;
	AktMin := Minuten;
	AktSek := Sekunden;
	ShowTime;
end;

procedure TWeckerForm.WeckerTimerTimer(Sender: TObject);
begin
	if RollStatus then begin
		case What of
			aMUp		: inc(Minuten);
			aMDown	: dec(Minuten);
			aSUp		: inc(Sekunden);
			aSDown	: dec(Sekunden);
		end;
      DoRefresh;
	end
	else	begin
				dec(AktSek);
				if AktSek<0 then begin
					AktSek := 59;
					dec(AktMin);
				end;
				ShowTime;
				if AktMin+AktSek=0 then begin
					WeckerTimer.Enabled := False;
					sndPlaySound('KLINGELN.WAV', SND_SYNC);
					sndPlaySound('KLINGELN.WAV', SND_SYNC);
					sndPlaySound('KLINGELN.WAV', SND_SYNC);
					BBStopClick(Sender);
				end;
			end;
end;

procedure TWeckerForm.BBMinUpClick(Sender: TObject);
begin
	inc(Minuten);
	DoRefresh;
end;

procedure TWeckerForm.BBSekUpClick(Sender: TObject);
begin
	inc(Sekunden);
	DoRefresh;
end;

procedure TWeckerForm.BBMinDownClick(Sender: TObject);
begin
	dec(Minuten);
	DoRefresh;
end;

procedure TWeckerForm.BBSekDownClick(Sender: TObject);
begin
	dec(Sekunden);
	DoRefresh;
end;

procedure TWeckerForm.DoRefresh;
begin
	if Minuten<0 then
		Minuten := 60;
	if Minuten>60 then
		Minuten := 0;
	if Sekunden<0 then
		Sekunden:= 59;
	if Sekunden>59 then
		Sekunden := 0;
	if Minuten+Sekunden>0 then
		BBStart.Enabled := True
	else BBStart.Enabled := False;
	AktMin := Minuten;
	AktSek := Sekunden;
	ShowTime;
end;

procedure TWeckerForm.FormShow(Sender: TObject);
begin
	ShowTime;
end;

procedure TWeckerForm.SBClearClick(Sender: TObject);
begin
	Minuten := 0;
	Sekunden := 0;
	DoRefresh;
end;

procedure TWeckerForm.BBSekUpMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	WeckerTimer.Enabled := False;
	RollStatus := False;
end;

procedure TWeckerForm.BBMinUpMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	RollStatus := True;
	WeckerTimer.Interval := 200;
	WeckerTimer.Enabled := True;
	with Sender as TBitBtn do begin
		if Name='BBMinUp' then
			What := aMUp;
		if Name='BBMinDown' then
			What := aMDown;
		if Name='BBSekUp' then
			What := aSUp;
		if Name='BBSekDown' then
			What := aSDown;
	end;
end;

procedure TWeckerForm.FormClick(Sender: TObject);
begin
	Application.CreateForm(TAboutForm, AboutForm);
	AboutForm.ShowModal;
	AboutForm.Free;
end;

end.
